<!DOCTYPE html>
<html lang="en">
{% include 'header.html' %}
<body>
{% include 'menu.html' %}
<div id="segment_id">
    <div class="ui grid">
        <div class="ui column" style="width: 75px; padding-top: 50px;">
            {% include 'project/sidebar.html' %}
        </div>
        <div class="ui column" style="width: calc(100% - 75px)">
            <div>
                {% set issues = db.select_project_issues(current_project['id']) %}
                <h1 class="ui header" style="float: left">Issues: {{ len(issues) }}</h1>
                <a class="ui button blue" style="float:right" href="/project/{{ current_project['id'] }}/new_issue"><i
                        class="plus icon"></i>Add</a>
                <div class="ui floating dropdown labeled icon button green" style="float:right" id="template_dropdown">
                    <i class="plus icon"></i>
                    <span class="text">Add from template</span>
                    <div class="menu"  style="z-index: 999;">
                        <div class="ui icon search input">
                            <i class="search icon"></i>
                            <input type="text" placeholder="Search template...">
                        </div>
                        <div class="divider"></div>
                        <div class="header">
                            <i class="tags icon"></i>
                            Issue templates
                        </div>
                        <div class="scrolling menu">
                            <a target="_blank" rel="noopener noreferrer" class="item" href="/profile#/config" style="width: 285px; white-space:normal; word-break: break-all">
                                <div></div>
                                <i class="yellow star outline icon"></i>Create a new template
                            </a>
                            {% set issue_templates = db.select_user_issue_templates(current_user['id']) %}
                            {% for current_template in issue_templates %}
                                {% if current_template['cvss'] == 0 %}
                                    {% set template_color = 'blue' %}
                                {% elif current_template['cvss'] <=3.9 %}
                                    {% set template_color = 'green' %}
                                {% elif current_template['cvss'] <= 6.9 %}
                                    {% set template_color = 'yellow' %}
                                {% elif current_template['cvss'] <= 8.9 %}
                                    {% set template_color = 'orange' %}
                                {% else %}
                                    {% set template_color = 'red' %}
                                {% endif %}
                                <a target="_blank" rel="noopener noreferrer" class="item" href="/project/{{ current_project['id'] }}/issue_template/{{ current_template['id'] }}/" style="width: 100%; white-space:normal; word-break: break-all">
                                    <div class="ui {{ template_color }} empty circular label"></div>
                                    {{ escape(current_template['tpl_name']) }} ({% if current_template['user_id'] %}Personal{% else %}Team: {{ db.select_team_by_id(current_template['team_id'])[0]['name'] }}{% endif %})</a>
                            {% endfor %}
                        </div>
                    </div>
                </div>
                <div class="ui divider" style="float:left; width: 100%"></div>
            </div>
            <form id="issue_rule_form" action="/project/{{ current_project['id'] }}/issues/rules" method="post" target="_blank" style="visibility: hidden;">
                <input name="csrf_token" value="{{ csrf_token() }}">
                <input id="issue_rule_ids" name="issue_ids" value="">
            </form>
            <script>

                function use_rules(){
                    issues_ids = [];
                    checkboxes = document.querySelectorAll('[id=issue_checkbox]');
                    for (i = 0; i < checkboxes.length; i++) {
                        curr_checkbox = checkboxes[i];
                        if (curr_checkbox.checked) {
                            issues_ids.push(curr_checkbox.parentElement.parentElement.attributes[0].value);
                        }
                    }
                    if (!issues_ids.length) {
                        return null;
                    }

                    $('#issue_rule_ids')[0].value = issues_ids.join(',');
                    $('#issue_rule_form')[0].submit();
                }

                function update_multiple_issues(){
                    //get host ids
                    issues_ids = [];
                    checkboxes = document.querySelectorAll('[id=issue_checkbox]');
                    for (i = 0; i < checkboxes.length; i++) {
                        curr_checkbox = checkboxes[i];
                        if (curr_checkbox.checked) {
                            issues_ids.push(curr_checkbox.parentElement.parentElement.attributes[0].value);
                        }
                    }
                    if (!issues_ids.length) {
                        return null;
                    }
                    if (confirm('Update ' + issues_ids.length + ' issues?')) {
                        csrf = '{{ csrf_token() }}';
                        data = {};
                        for (i = 0; i < issues_ids.length; i++) {
                            data['issue-' + (i + 1)] = issues_ids[i];
                        }
                        data['csrf_token'] = csrf;

                        data['criticality'] = $('#criticality_list')[0].children[0].value;
                        data['status'] = $('#status_list')[0].children[0].value;

                        console.log('Update');
                        console.log(data);
                        $.ajax({
                            type: "POST",
                            url: '/project/{{ current_project['id'] }}/issues/multiple_edit',
                            data: data,
                        }).done(function (response) {
                            if (response === "ok") {
                                document.location.reload();
                            }
                        });

                    } else {
                        // Do nothing!
                        console.log('Thing was not saved to the database.');
                    }
                }

                $(document).ready(function () {
                    var table = $('#issues_list').DataTable({
                        "order": [[4, "desc"]],
                        "iDisplayLength": -1,
                        aLengthMenu: [
                            [10, 25, 50, 100, 200, -1],
                            [10, 25, 50, 100, 200, "All"]
                        ],
                        'columnDefs': [
                            {
                                'targets': 0,
                                'searchable': false,
                                'orderable': false,
                            }, {
                                'targets': 6,
                                'searchable': false,
                                'orderable': false,
                            }],
                        "initComplete": function (settings, json) {
                            //div_block = $('#issues_list_length')[0];
                            const button = document.createElement('button');
                            button.type = "button";
                            button.name = "action";
                            button.style.all = "margin-left: 15px; float: left;";
                            button.setAttribute( "onClick", "javascript: delete_issues();" );
                            button.classList.value = "ui vertical animated button red";
                            button.tabIndex = "0";
                            button.innerHTML = `<div class="hidden content">Delete</div>
                                                <div class="visible content">
                                                <i class="trash icon"></i></div>`;
                            button.style.float = 'left'

                            const rule_button = document.createElement('button');
                            rule_button.type = "button";
                            rule_button.name = "action";
                            rule_button.style.all = "margin-left: 15px; float: left;";
                            rule_button.setAttribute( "onClick", "javascript: use_rules();" );
                            rule_button.classList.value = "ui vertical animated button orange";
                            rule_button.tabIndex = "0";
                            rule_button.innerHTML = `<div class="hidden content">Use rules</div>
                                                <div class="visible content">
                                                <i class="filter icon"></i></div>`;
                            rule_button.style.float = 'left'

                            issue_elem = document.getElementById('issues_list_length')
                            issue_elem.appendChild(button);
                            issue_elem.appendChild(rule_button);
                            issue_elem.innerHTML = issue_elem.innerHTML + `
<div class="ui field" style="float: right;z-index: 999;">
	<div class="ui labeled input">
		<div class="ui label" style="width: 120px;">
			<i class="exclamation triangle icon"></i>Criticality:
		</div>
		<div class="ui fluid selection dropdown" id="criticality_list" style="width: 230px !important;">
			<input type="hidden" name="criticality" required value="-1">
			<i class="dropdown icon"></i>
			<div class="default text">Select criticality</div>
			<div class="menu">
				<div class="item" data-value="-1">Do not change</div>
				<div class="item" data-value="0"><i class="warning circle blue icon"></i>Information
					(cvss=0.0)
				</div>
				<div class="item" data-value="2"><i class="warning circle green icon"></i>Low
					(cvss=2.0)
				</div>
				<div class="item" data-value="5"><i class="warning circle yellow icon"></i>Medium
					(cvss=5.0)
				</div>
				<div class="item" data-value="8"><i class="warning circle orange icon"></i>High
					(cvss=8.0)
				</div>
				<div class="item" data-value="9.5"><i class="warning circle red icon"></i>Critical
					(cvss=9.5)
				</div>
			</div>
		</div>
	</div>
</div>
`;
                            parent_elem = issue_elem.parentElement.parentElement;
                            first_row = $('.ui.stackable.grid .row:first');
                            first_row.css({
                                'top': 0,
                                'position': "sticky",
                                'z-index': 900,
                                'background-color': 'white'
                            });
                            table_header = $('#issues_header');
                            table_header.css({
                                'top': "66px",
                                'position': "sticky",
                                'z-index': 100,
                                'background-color': 'white'
                            });

                            $('#issues_list_length')[0].children[0].style.float = 'left';
                            $('#issues_list_filter')[0].style.width = "250px";
                            $('#issues_list_filter')[0].style.float = "right";

                            second_column = $('#issues_list_wrapper')[0].children[0].children[0].children[1];

                            second_column.insertAdjacentHTML('beforeend',`
<div class="ui field"  style="float: left;z-index: 999;">
    <div class="ui labeled input">
        <div class="ui label" style="width: 100px;">
            <i class="question circle icon"></i>Status:
        </div>
        <div class="ui fluid selection dropdown" id="status_list">
            <input type="hidden" name="status" required value="-1">
            <i class="dropdown icon"></i>
            <div class="default text">Select status</div>
            <div class="menu">
                <div class="item" data-value="-1">(no changes)</div>
                <div class="item" data-value="PoC creation">PoC creation</div>
                <div class="item" data-value="PoC available">PoC available</div>
                <div class="item" data-value="Confirmed">Confirmed</div>
                <div class="item" data-value="Wasn't Confirmed">Wasn't Confirmed</div>
                <div class="item" data-value="Pending...">Pending...</div>
                <div class="item" data-value="Need to check">Need to check</div>
                <div class="item" data-value="Need to recheck">Need to recheck</div>
            </div>
        </div>
    </div>
</div>`);

                            /////
                            const button_update = document.createElement('button');
                            button_update.type = "submit";
                            button_update.name = "action";
                            button_update.id = "button_update";
                            button_update.onclick = update_multiple_issues;
                            button_update.classList.value = "ui vertical animated button green";
                            button_update.tabIndex = "0";
                            button_update.innerHTML = `<div class="hidden content">Update</div>
                                                <div class="visible content">
                                                <i class="sync icon"></i></div>`;
                            second_column.appendChild(button_update);
                            $('#button_update').css({
                                'margin-left': "15px",
                                'float': 'left'
                            });
                            $('.ui.dropdown.selection').dropdown({});
                        }
                    });

                    $(document).on("click", "#example-select-all", function (e) {
                        checkboxes = document.querySelectorAll('[id=issue_checkbox]');
                        for (i = 0; i < checkboxes.length; i++) {
                            checkboxes[i].checked = this.checked;
                        }

                    });

                    rows = document.getElementsByTagName("tr");
                    i = 1;
                    while (i < rows.length) {
                        if (rows[i].children[0].id === "checkbox_data") {
                            cvss = parseFloat(rows[i].children[4].innerText);
                            console.log(cvss);
                            if (cvss == 0) {
                                rows[i].style.backgroundColor = '#c0f7ff';
                            } else if (cvss <= 3.9) {
                                rows[i].style.backgroundColor = '#c3ffcd';
                            } else if (cvss <= 6.9) {
                                rows[i].style.backgroundColor = '#fffdc2';
                            } else if (cvss <= 8.9) {
                                rows[i].style.backgroundColor = '#f3c375';
                            } else {
                                rows[i].style.backgroundColor = '#ffb2b2';
                            }
                        }
                        i++;
                    }

                    $('#template_dropdown').dropdown({
                        match: 'text',
                        ignoreCase: true,
                        fullTextSearch: true

                    });
                })
                ;


                function delete_issues() {
                    //get host ids
                    issues_ids = [];
                    checkboxes = document.querySelectorAll('[id=issue_checkbox]');
                    for (i = 0; i < checkboxes.length; i++) {
                        curr_checkbox = checkboxes[i];
                        if (curr_checkbox.checked) {
                            issues_ids.push(curr_checkbox.parentElement.parentElement.attributes[0].value);
                        }
                    }
                    if (!issues_ids.length) {
                        return null;
                    }
                    if (confirm('Delete ' + issues_ids.length + ' issues?')) {
                        csrf = '{{ csrf_token() }}';
                        data = ''
                        for (i = 0; i < issues_ids.length; i++) {
                            data += 'issue-' + (i + 1) + '=' + issues_ids[i] + '&'
                        }
                        data += 'csrf_token=' + csrf;
                        console.log('Delete');
                        console.log(data);
                        $.ajax({
                            type: "POST",
                            url: '/project/{{ current_project['id'] }}/issues/multiple_delete',
                            data: data,
                        }).done(function (response) {
                            if (response === "ok") {
                                document.location.reload();
                            }
                        });

                    } else {
                        // Do nothing!
                        console.log('Thing was not saved to the database.');
                    }
                }
            </script>
            <style>
                tr.odd {
                    background-color: #fffdc2;
                }

                tr.even {
                    background-color: #c3ffcd;
                }

                .ui.menu:last-child {
                    margin-bottom: 0px;
                }
                #dataTables_length .label {
                    float: left;
                }
            </style>
            <div class="ui container" style="width: 100%;float:left;">
                <table id="issues_list" class="ui table" style="width: 100%">
                    <thead id="issues_header">
                    <tr id="table_header">
                        <th style="width: 20px;">
                            <div class="ui fitted big checkbox">
                                <input name="select_all" style="transform: scale(1.2); margin-left: 4px;" value="1" id="example-select-all" type="checkbox">
                                <label></label>
                            </div>
                        </th>
                        <th style="width: 200px;"><h4>name</h4></th>
                        <th style="width: 800px;"><h4>description</h4></th>
                        <th style="min-width: 300px;"><h4>services</h4></th>
                        <th style="min-width: 100px;"><h4>CVSS</h4></th>
                        <th><h4>status</h4></th>
                        <th><h4>action</h4></th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for issue in issues %}
                        <tr>
                            <td data-value="{{ issue['id'] }}" id="checkbox_data">
                                <div class="ui fitted big checkbox">
                                    <input type="checkbox" style="transform: scale(1.2); margin-left: 4px;" name="issue_checkbox" id="issue_checkbox">
                                    <label></label>
                                </div>
                            </td>
                            <td style="word-break: break-all; white-space:pre-wrap;"><b>{{ escape(issue['name']) }}</b></td>
                            <td style="word-break: break-all; white-space:pre-wrap;">{{ escape('\n'.join(issue['description'].split('\n')[:5])) }}</td>
                            <td>
                                <ul class="ui list">
                                    {% set addresses = json_unpack(issue['services']) %}
                                    {% set counter = [0] %}
                                    {% for port_id in addresses %}
                                        {% set port = db.select_port(port_id)[0] %}
                                        {% for host in addresses[port_id] %}
                                            {% if counter[0] < 5 %}
                                                {% if host=="0" %}
                                                    {% set ip = db.select_host_by_port_id(port_id)[0] %}
                                                    <li>{{ escape(ip['ip']) }}{% if port['port'] != 0 %}:{{ escape(port['port']) }}{% endif %}</li>
                                                {% else %}
                                                    {% set hostname = db.select_hostname(host)[0] %}
                                                    <li>{{ escape(hostname['hostname']) }}{% if port['port'] != 0 %}:{{ escape(port['port']) }}{% endif %}</li>
                                                {% endif %}
                                            {% endif %}
                                            {% if counter.append(counter.pop() + 1) %}{% endif %}
                                        {% endfor %}
                                    {% endfor %}
                                    {% if counter[0] >5 %}
                                        ...<br/>
                                        {{ counter[0] }} hosts at all!
                                    {% endif %}
                                </ul>
                            </td>
                            <td>{{ escape(issue['cvss']) }}</td>
                            <td>{{ escape(issue['status']) }}</td>
                            <td><a class="ui button blue"
                                   href="/project/{{ current_project['id'] }}/issue/{{ issue['id'] }}/">Open</a></td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
        {% include 'footer.html' %}
    </div>
</div>
</body>
</html>